﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=8.3
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: True
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	Private working As Boolean = True
	Public mqtt As MqttClient
	Private username As String = ""
	Private password As String = ""
	Public temp As String
	Public strBroker As String
	
	Dim rp As RuntimePermissions
	
	Dim mySQL As SQL
	Dim myCUR As Cursor
	Dim query As String
	
	Dim mySQL2 As SQL
	Dim myCUR2 As Cursor
	Dim query2 As String
	
	Dim DBName As String : DBName = "BrokerDB.db"
	Dim DBDir As String : DBDir = File.DirInternal
	
	Dim DBName2 As String : DBName2 = "descoveryDB.db"
	Dim DBDir2 As String : DBDir2 = File.DirInternal
	

	Dim BrokerAddress As String
	Dim BrokerPort As String
	Dim brokerTopic As String
	
	Dim grouplist As List
	Dim devlist As List
	
	Dim rowid As Int
End Sub


Sub SaveDB()
	If File.Exists(DBDir, DBName) = False Then
		File.Copy(File.DirAssets, DBName, DBDir, DBName)
	End If
End Sub

Sub ConnectionDB()
	mySQL.Initialize(DBDir,DBName,True)
End Sub


Sub SaveDB2
	If File.Exists(DBDir2, DBName2) = False Then
		File.Copy(File.DirAssets, DBName2, DBDir2, DBName2)
	End If
End Sub

Sub ConnectionDB2
	mySQL2.Initialize(DBDir2,DBName2,True)
End Sub

Sub retrieveDB()
	myCUR = mySQL.ExecQuery("SELECT Broker_name, Port_name, Topic_name FROM Broker")
	For i = 0 To myCUR.RowCount-1
		myCUR.Position=i
		BrokerAddress = myCUR.GetString("Broker_name")
		BrokerPort = myCUR.GetString("Port_name")
	'brokerTopic = myCUR.GetString("Topic_name")
	Next
	myCUR.Close
	
	
End Sub

Sub Service_Create
	SaveDB
	ConnectionDB
	retrieveDB
	
	CombineBroker

	SaveDB2
	ConnectionDB2
	working = True
	mqtt.Initialize("mqtt", strBroker, "B4X" & Rnd(0, 999999999))
	ConnectAndReconnect
End Sub

Sub ConnectAndReconnect
	Do While working
		If mqtt.IsInitialized Then mqtt.Close
'''THIS NEEDS TO BE UPDATED TO REFLECT VARIABLE:
		'mqtt.Initialize("mqtt", "tcp://138.68.141.233:1883", "B4X" & Rnd(0, 999999999))
		mqtt.Initialize("mqtt", strBroker, "B4X" & Rnd(0, 999999999))
		
		Dim mo As MqttConnectOptions
		mo.Initialize(username, password)
		Log("Trying to connect")
		mqtt.Connect2(mo)
		Wait For Mqtt_Connected (Success As Boolean)
		If Success Then
			Log("Mqtt connected")
			AfterConnect
			Do While working And mqtt.Connected
				mqtt.Publish2($"${username}/f/ping"$, Array As Byte(0), 1, False)
				Sleep(5000)
			Loop
			Log("Disconnected")
		Else
			Log("Error connecting.")
		End If
		UpdateState
		Sleep(5000)
	Loop
End Sub

Private Sub AfterConnect
	myCUR2 = mySQL2.ExecQuery("SELECT topic FROM topicsplit")
	For d = 0 To myCUR2.RowCount - 1
		myCUR2.Position = d
		Dim top As String = myCUR2.GetString("topic")
		mqtt.Subscribe(top,0)
	Next
	myCUR2.Close
	UpdateState
End Sub


Sub mqtt_MessageArrived (Topic As String, Payload() As Byte)
		temp = BytesToString(Payload, 0, Payload.Length, "ascii")
		If temp == "" Then
			temp = "OFF"
	End If
	query = "SELECT rowid FROM topicsplit  WHERE topic = ?"
	myCUR2 = mySQL2.ExecQuery2(query,Array As String(Topic))
	For i = 0 To myCUR2.RowCount - 1
		myCUR2.Position = i
		rowid = myCUR2.GetString("rowid")
		Log(Topic)
		Log(rowid)
	Next
		UpdateState
	
		
	'End If
End Sub

Sub CombineBroker()
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("tcp://").Append(BrokerAddress).Append(":").Append(BrokerPort)
	strBroker = sb.ToString
End Sub


Sub UpdateState
	CallSub(Main,"SetState")
End Sub


Sub Service_Start (StartingIntent As Intent)
End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy
End Sub

